package com.logicbig.example;

import javax.swing.*;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import java.util.Vector;
import java.util.regex.Pattern;

public class TableHelper {

    public static JTable createTable() {
        //prepare columns
        Vector<String> columns = new Vector<>();
        columns.add("Name");
        columns.add("Dept");
        columns.add("Phone");
        columns.add("Address");

        //prepare rows
        Vector<Vector<String>> rows = new Vector();
        for (Employee employee : EmployeeDataAccess.getEmployees()) {
            Vector<String> row = new Vector<>();
            row.add(employee.getName());
            row.add(employee.getDept());
            row.add(employee.getPhone());
            row.add(employee.getAddress());
            rows.add(row);
        }
        return new JTable(rows, columns);
    }

    public static boolean searchInTable(JTable table, String searchText) {
        if (searchText == null) {
            return false;
        }
        int beforeFilterRowCount = table.getRowCount();
        RowSorter<? extends TableModel> rs = table.getRowSorter();
        if (rs == null) {
            table.setAutoCreateRowSorter(true);
            rs = table.getRowSorter();
        }
        TableRowSorter<? extends TableModel> rowSorter = (TableRowSorter<? extends TableModel>) rs;
        if (searchText.length() == 0) {
            rowSorter.setRowFilter(null);
        } else {
            rowSorter.setRowFilter(RowFilter.regexFilter("(?i)" + Pattern.quote(searchText)));
        }
        int afterFilterRowCount = table.getRowCount();
        return afterFilterRowCount!=0 && afterFilterRowCount != beforeFilterRowCount;
    }
}